#ifndef __RPC_ID__
#define __RPC_ID__

enum rpcid {
	RPC_UNDEF,
	RPC_ACK,
	RPC_FORWARD_DATA,
	RPC_ADVERT_FORWARD,
	RPC_TEST,
	RPC_PINGPONG,

	RPC_FAF_INIT_SERVER,
	RPC_FAF_READ,
	RPC_FAF_WRITE,
	RPC_FAF_READV,
	RPC_FAF_WRITEV,
	RPC_FAF_GETDENTS,
	RPC_FAF_LSEEK,
	RPC_FAF_LLSEEK,
	RPC_FAF_IOCTL,
	RPC_FAF_FCNTL,
	RPC_FAF_FCNTL64,
	RPC_FAF_FSTAT,
	RPC_FAF_FSTATFS,
	RPC_FAF_FSYNC,
	RPC_FAF_FLOCK,
	RPC_FAF_POLL_WAIT,
	RPC_FAF_POLL_DEQUEUE,
	RPC_FAF_POLL_NOTIFY,
	RPC_FAF_D_PATH,
	RPC_FAF_BIND,
	RPC_FAF_CONNECT,
	RPC_FAF_LISTEN,
	RPC_FAF_ACCEPT,
	RPC_FAF_GETSOCKNAME,
	RPC_FAF_GETPEERNAME,
	RPC_FAF_SHUTDOWN,
	RPC_FAF_SETSOCKOPT,
	RPC_FAF_GETSOCKOPT,
	RPC_FAF_SENDMSG,
	RPC_FAF_RECVMSG,
	RPC_FAF_SENDFILE,
	RPC_FAF_NOTIFY_CLOSE,

/* Ctnr Object Server Types */
	REQ_OBJECT_COPY,
	REQ_OBJECT_INVALID,
	REQ_OBJECT_REMOVE,
	REQ_OBJECT_REMOVE_TO_MGR,

	SEND_BACK_FIRST_TOUCH,
	OBJECT_SEND,
	NO_OBJECT_SEND,
	SEND_WRITE_ACCESS,
	INVALIDATION_ACK,
	REMOVE_ACK,
	REMOVE_ACK2,
	REMOVE_DONE,
	SEND_OWNERSHIP,
	CHANGE_OWNERSHIP_ACK,

/* Ctnr Container Manager Types */
	REQ_KDDM_SET_LOOKUP,
	REQ_KDDM_SET_DESTROY,
	SEND_KDDM_SET_CREATE_DATA,
	REQ_INC_KDDM_SET_USE,
	REQ_DEC_KDDM_SET_USE,

	GENERIC_ACK_REQUEST,
	REQ_KILL_THREAD,

	REQ_TEST_BARRIER,
	REQ_TEST_LOCK,
	REQ_TEST_SEM,
	REQ_TEST_COND,
	REQ_TEST_RES,
	TEST_DATA,
	INIT_DATA,

/* Aragorn Message Types */
	/* gthread server Types, reflected in the command_name table */
	GTHREAD_MSG_TYPE,
	KRG_THREAD_DETACH_REQUEST,
	KRG_THREAD_STOP_NOTIFICATION,
	KRG_THREAD_ADD_THREAD_INFO,
	KRG_THREAD_REMOVE_THREAD_INFO,
	KRG_THREAD_UPDATE_STATE_INFO,
	KRG_THREAD_WAS_DESTROYED_NOTIFICATION,
	KRG_THREAD_DO_EXIT_REQUEST,
	KRG_THREAD_HAS_EXITED_NOTIFICATION,
	KRG_THREAD_FINISH_JOIN_REQUEST,
	KRG_THREAD_BLOCKED_ON_JOIN_NOTIFICATION,
	KRG_THREAD_MIGRATION_STARTED_NOTIFICATION,
	KRG_THREAD_MIGRATION_FINISHED_NOTIFICATION,
	STOP_ALL_THREADS_REQUEST,
	END_REQUEST,
	ARAG_TIMER_TYPE,
	SIGNAL_MGR_SEND_NODEID,
	SIGNAL_MGR_SEND_PID,
	SIGNAL_MGR_SEND_TID,
	SIGNAL_MGR_SEND_REQTYPE,
	SIGNAL_MGR_SEND_SIG,
	SIGNAL_MGR_SEND_SIGINFO,
	PGM_MSG_TYPE,
	SCHEDULER_MSG_TYPE,

/* Aragorn Messages for Synch */

	APP_STOP,
	APP_CONTINUE,
	APP_KILL,

	APP_REMOTE_CHKPT,
	APP_DO_CHKPT,

	APP_INIT_RESTART,
	APP_DO_RESTART,

	APP_EXCL_MM_REGION,

	RPC_EPM_REMOTE_CLONE,
	RPC_EPM_MIGRATE,
	EPM_CHECKPOINT_REQ,

	ARAGORN_SYS_KILL,
	PROC_KILL_PROC_INFO,
	PROC_SCHED_SETSCHEDULER,
	PROC_SCHED_GETPARAM,
	PROC_SCHED_GETSCHEDULER,
	PROC_KILL_PG_INFO,
	ARAGORN_SESSION_GROUP,
	ARAGORN_WILL_NOT_BECOME_ORPHANED_PGRP,
	ARAGORN_SYS_SETPGID,
	PROC_FORWARD_SETPGID,
	PROC_GETPGID,
	PROC_GETSID,
	ARAGORN_UPDATE_PGRP,
	PROC_WAKE_UP_PROCESS,
	PROC_GET_PID_CAP,
	PROC_SET_PID_CAP,
	PROC_REQUEST_MIGRATION,
	PROC_DO_NOTIFY_PARENT,
	PROC_NOTIFY_REMOTE_CHILD_REAPER,
	PROC_WAIT_TASK_ZOMBIE,
	PROC_VFORK_DONE,
	PROC_RESERVE_PID,
	PROC_PID_LINK_TASK,
	PROC_END_PID_RESERVATION,
	EPM_PIDMAP_STEAL,

	PROC_GETPRIORITY_PROCESS,
	PROC_GETPRIORITY_PG_USER,
	PROC_SETPRIORITY_PROCESS,
	PROC_SETPRIORITY_PG_USER,

/** System V IPC messages types */
	IPC_MSG_SEND,
	IPC_MSG_RCV,
	IPC_MSG_CHKPT,

/** System V IPC semaphores */
	IPC_SEM_WAKEUP,

/** group management */
	REQ_CREATE_ARAGORN_GROUP,
	REQ_ADD_PROCESS_IN_ARAGORN_GROUP,
	REQ_ADD_THREAD_IN_ARAGORN_GROUP,
	REQ_REMOVE_PROCESS_FROM_ARAGORN_GROUP,
	REQ_REMOVE_THREAD_FROM_ARAGORN_GROUP,
	REQ_ADD_NODE_IN_ARAGORN_GROUP,
	REQ_REMOVE_NODE_FROM_ARAGORN_GROUP,
	REQ_GET_ARAGORN_GROUP,
	REQ_GET_ARAGORN_GROUP_NODE_USAGE,
	REQ_DELETE_ARAGORN_GROUP,

	SYNC_SELFTEST_SYNC,

	REQ_DYNAMIC_INFO_UPDATE,
	REQ_AVAILABLE_TGIDS,
	REQ_TASK_LOCATION,
	REQ_PROC_PID_ENVIRON,
	REQ_PROC_PID_CMDLINE,
	REQ_PROC_PID_AUXV,
	REQ_PROC_PID_LIMITS,
	REQ_PROC_PID_SYSCALL,
	REQ_PROC_PID_WCHAN,
	REQ_PROC_PID_SCHEDSTAT,
	REQ_PROC_PID_OOM_SCORE,
	REQ_PROC_TGID_IO_ACCOUNTING,
	REQ_PROC_PID_STATUS,
	REQ_PROC_PID_PERSONALITY,
	REQ_PROC_TGID_STAT,
	REQ_PROC_PID_STATM,
	REQ_PROC_PID_STACK,
	REQ_PROC_PID_FD,

	HEARTBEAT_SIGNAL,
	HEARTBEAT_FAILURE,
	HEARTBEAT_MONCHANGE,

	KDDM_COPYSET,
	KDDM_SELECT_OWNER,
	KDDM_CHANGE_PROB_OWNER,

	NODE_ADD,
	NODE_REMOVE,
	NODE_REMOVE_ADVERTISE,
	NODE_REMOVE_ACK,
	NODE_REMOVE_CONFIRM,
	NODE_FAIL,
	NODE_POWEROFF,
	NODE_REBOOT,

	NODE_FWD_ADD,
	NODE_FWD_REMOVE,

	RPC_MM_MMAP_REGION,
	RPC_MM_MUNMAP,
	RPC_MM_MREMAP,
	RPC_MM_DO_BRK,
	RPC_MM_EXPAND_STACK,
	RPC_MM_MPROTECT,
	RPC_MM_NOTIFY_LOW_MEM,

	CLUSTER_START,
	CLUSTER_STOP,

	GLOBAL_CONFIG_OP,
	SCHED_PIPE_GET_REMOTE_VALUE,

	RPC_ENTER_BARRIER,
	RPC_EXIT_BARRIER,

	CLUSTER_IP_UNUSED,

	KDDM_BENCH,

	RPCID_MAX // Must be the last one
};

#endif
